/*
͸
 Source file: DBFNSX2.CH                                                  
 Description: #Include file for HiPer-SIx v1.1 for Clipper 5.01a          
 Notes      : Include this file (#include "SIXNSX2.CH") in your program's 
              source code INSTEAD of SIXNSX.CH to use EXTENDED EXPRESSIONS
 Last Update: 12/01/93                                                    
 Notice     : Copyright 1992, 1993 - SuccessWare 90, Inc.                 
;
  
*/

EXTERN _VDBFNSX

#command SET INDEX TO [ <(index1)> [, <(indexn)>]]                         ;
      => dbClearIndex()                                                    ;
      [; dbSetIndex( <(index1)> )]                                         ;
      [; dbSetIndex( <(indexn)> )]

#command SET INDEX TO [ <(index1)> [, <(indexn)>]] ADDITIVE                ;
      => [dbSetIndex( <(index1)> )]                                        ;
         [; dbSetIndex( <(indexn)> )]

#command SET TAGORDER TO <order>                                           ;
      => Sx_SetTagOrder( <order> )

#command SET TAGORDER TO                                                   ;
      => Sx_SetTagOrder( 0 )

#command SET ORDER TO TAG <(tag)> [OF <(cdx)>]                             ;
      => Sx_SetTag( <(tag)>, <(cdx)> )

#command SET TAG TO <(tag)> [OF <(cdx)>]                                   ;
      => Sx_SetTag( <(tag)>, <(cdx)> )

#command SET TAG TO                                                        ;
      => dbSetOrder(0)

#command SUBINDEX ON <key> TO <(file)>                                     ;
         [FOR <for>]                                                       ;
         [<all:   ALL>]                                                    ;
         [WHILE   <while>]                                                 ;
         [NEXT    <next>]                                                  ;
         [RECORD  <rec>]                                                   ;
         [<rest:  REST>]                                                   ;
         [<u:     UNIQUE>]                                                 ;
         [OPTION  <opt> [STEP <step>]]                                     ;
         [EVAL    <opt> [EVERY <step>]]                                    ;
         [<add:   ADDITIVE>]                                               ;
         [<filt:  FILTERON>]                                               ;
         [NOOPTIMIZE]                                                      ;
                                                                           ;
      => _sxCondSet( <(for)>, NIL,                                        ;
                      if( <.all.>, .t., NIL ),                             ;
                      <{while}>,                                           ;
                      <{opt}>, <step>    ,                                 ;
                      RECNO(), <next>, <rec>,                              ;
                      if( <.rest.>, .t., NIL ),                            ;
                      NIL, .f., NIL, .t., NIL, NIL, <.add.>, <.filt.>)     ;
       ; dbCreateIndex(<(file)>, <(key)>, NIL,                             ;
                        if(<.u.>, .t., NIL))                               ;


#command SUBINDEX ON <key> TAG <(tag)> [OF <(nsx)>]                        ;
         [FOR <for>]                                                       ;
         [<all:   ALL>]                                                    ;
         [WHILE   <while>]                                                 ;
         [NEXT    <next>]                                                  ;
         [RECORD  <rec>]                                                   ;
         [<rest:  REST>]                                                   ;
         [<u:     UNIQUE>]                                                 ;
         [OPTION  <opt> [STEP <step>]]                                     ;
         [EVAL    <opt> [EVERY <step>]]                                    ;
         [<add:   ADDITIVE>]                                               ;
         [<filt:  FILTERON>]                                               ;
         [NOOPTIMIZE]                                                      ;
                                                                           ;
      => _sxCondSet(<(for)>, NIL,                                         ;
                      if( <.all.>, .t., NIL ),                             ;
                      <{while}>,                                           ;
                      <{opt}>, <step>    ,                                 ;
                      RECNO(), <next>, <rec>,                              ;
                      if( <.rest.>, .t., NIL ),                            ;
                      NIL, .t., <(nsx)>, .t., NIL, NIL, <.add.>, NIL,      ;
                      <.filt.>)                                            ;
       ; dbCreateIndex(<(tag)>, <(key)>, NIL,                              ;
                        if(<.u.>, .t., NIL))                               ;

#command INDEX ON <key> TO <(file)>                                        ;
         [FOR <for>]                                                       ;
         [<all:   ALL>]                                                    ;
         [WHILE   <while>]                                                 ;
         [NEXT    <next>]                                                  ;
         [RECORD  <rec>]                                                   ;
         [<rest:  REST>]                                                   ;
         [<u:     UNIQUE>]                                                 ;
         [<cur:   USECURRENT>]                                             ;
         [<cur:   SUBINDEX>]                                               ;
         [OPTION  <opt> [STEP <step>]]                                     ;
         [EVAL    <opt> [EVERY <step>]]                                    ;
         [<add:   ADDITIVE>]                                               ;
         [<filt:  FILTERON>]                                               ;
         [NOOPTIMIZE]                                                      ;
                                                                           ;
      => _sxCondSet(<(for)>, NIL,                                         ;
                      if( <.all.>, .t., NIL ),                             ;
                      <{while}>,                                           ;
                      <{opt}>, <step>    ,                                 ;
                      RECNO(), <next>, <rec>,                              ;
                      if( <.rest.>, .t., NIL ),                            ;
                      NIL, .f., NIL, <.cur.>, NIL, NIL, <.add.>, NIL,      ;
                      <.filt.>)                                            ;
       ; dbCreateIndex(<(file)>, <(key)>, NIL,                             ;
                        if(<.u.>, .t., NIL))                               ;


#command INDEX ON <key> TAG <(tag)> [OF <(nsx)>]                           ;
         [FOR <for>]                                                       ;
         [<all:   ALL>]                                                    ;
         [WHILE   <while>]                                                 ;
         [NEXT    <next>]                                                  ;
         [RECORD  <rec>]                                                   ;
         [<rest:  REST>]                                                   ;
         [<u:     UNIQUE>]                                                 ;
         [<cur:   USECURRENT>]                                             ;
         [<cur:   SUBINDEX>]                                               ;
         [OPTION  <opt> [STEP <step>]]                                     ;
         [EVAL    <opt> [EVERY <step>]]                                    ;
         [<add:   ADDITIVE>]                                               ;
         [<filt:  FILTERON>]                                               ;
         [NOOPTIMIZE]                                                      ;
                                                                           ;
      => _sxCondSet(<(for)>, NIL,                                         ;
                      if( <.all.>, .t., NIL ),                             ;
                      <{while}>,                                           ;
                      <{opt}>, <step>    ,                                 ;
                      RECNO(), <next>, <rec>,                              ;
                      if( <.rest.>, .t., NIL ),                            ;
                      NIL, .t., <(nsx)>, <.cur.>, NIL, NIL, <.add.>,       ;
                      NIL, <.filt.>)                                       ;
       ; dbCreateIndex(<(tag)>, <(key)>, NIL,                              ;
                        if(<.u.>, .t., NIL))                               ;


#command REINDEX                                                           ;
         [EVAL    <opt> [EVERY <step>]]                                    ;
         [OPTION  <opt> [STEP <step>]]                                     ;
      => _sxCondSet(,,,, <{opt}>, <step>,,,,,,,,,,,)                       ;
       ; dbReindex()

#command DELETE TAG <(tag1)> [OF <(cdx1)>]                                 ;
         [, <(tagn)> [OF <(cdxn)>]]                                        ;
      => Sx_KillTag( <(tag1)>, <(cdx1)> )                                  ;
      [; Sx_KillTag( <(tagn)>, <(cdxn)> )]

#command DELETE TAG ALL [OF <(cdx)>]                                       ;
      => Sx_KillTag( .t., <(cdx)> )

// Clear both values
#command CLEAR SCOPE                                                       ;
      => Sx_ClrScope()

// First value, inclusive
#xcommand SET SCOPETOP TO <value>                                          ;
      => Sx_SetScope(0, <value>)

#xcommand SET SCOPETOP TO                                                  ;
      => Sx_ClrScope(0)

// Last value, inclusive
#xcommand SET SCOPEBOTTOM TO <value>                                       ;
      => Sx_SetScope(1, <value>)

#xcommand SET SCOPEBOTTOM TO                                               ;
      => Sx_ClrScope(1)

// Clear both values
#command SET SCOPE TO                                                      ;
      => Sx_ClrScope()

// Both values, inclusive
#command SET SCOPE TO <value>                                              ;
      => Sx_SetScope(0, <value>)                                           ;
       ; Sx_SetScope(1, <value>)

#command SORT [TO <(file)>] [ON <fields,...>]                              ;
         [FOR <for>]                                                       ;
         [WHILE <while>]                                                   ;
         [NEXT <next>]                                                     ;
         [RECORD <rec>]                                                    ;
         [<rest:REST>]                                                     ;
         [ALL]                                                             ;
         [<cur: USECURRENT>]                                               ;
         [NOOPTIMIZE]                                                      ;
                                                                           ;
      => Sx_SortOption(<.cur.>)                                            ;
       ; __dbSort(<(file)>, { <(fields)> },                                ;
                   <{for}>, <{while}>, <next>, <rec>, <.rest.>)           
